#include <iostream>
#include <thread>
#include <TSystem.h>

class MyClass {
public:
    void Read(int iCPU) {
        std::cout << "CPU #" << iCPU << " : Reading from MyClass" << std::endl;
        gSystem->Sleep(10000);
    }
};

void thread(MyClass &ptr, int i) {

    ptr.Read(i);
}

int main() {
    // Creating an instance of MyClass
    MyClass myObject;

    // Get the number of available CPU cores
    unsigned int numCores = std::thread::hardware_concurrency();

    // Creating a vector to store thread objects
    std::vector<std::thread> threads;

    // Creating threads equal to the number of CPU cores
    for (unsigned int i = 0; i < numCores; ++i) {
        threads.emplace_back(std::thread(&thread, std::ref(myObject), i));
    }

    // Joining all the threads to wait for their completion
    std::cout << "WAIT" << std::endl;
    for (auto& thread : threads) {
        thread.join();
    }
    std::cout << "DOOM" << std::endl;
    return 0;
}