#pragma once

#include <Rioplus.h>
#include <TObject.h>
#include <TString.h>
#include <TTree.h>
#include <TFile.h>

#include "FrameFormat/TFrameTypes.h"
#include "TPrint.h"

#define UNUSED(x) (void)(x) // Macro to hide all ununsed parameters

namespace FrameFormat {

    enum Verbosity {kUnchanged = -1, kNormal = 0, kInfo = 2, kDebug = 3, kAll = 5};

    class TFrameChain;
    class TFrameAbstract: public TObject
    {
        protected: 
            static Verbosity verbosity;

            static FILE *logFile;
            static TString logFileName;

        public:

            // TFrame verbosity control
            static Verbosity GetVerbosity();
            static void SetVerbosity(Verbosity verbosity);
            bool Verbose(Verbosity verbosity);

            // FrameL debug control 
            static void SetDebug(int debugLvl);

            // FrameL version
            static char *Version();
            static FILE *Logging(const char *name);
            
        ClassDef(TFrameAbstract, 1);
    };
};
