#pragma once

#include "FrameFormat/TFrameChain.h"

namespace FrameFormat {

        class TFrameStreamer: public TFrameChain
        {
                TFrameStreamer(TString fname, Option_t *option);
                virtual ~TFrameStreamer() { }

                TFrame *AddFrame(int nFrames, int fileID) = delete;
                TFrame *RemoveFrame(int fileID, int frameID) = delete;

                TFrame *AddFrame(TFrame *frame, int fileID) = delete;
                TFrame *RemoveFrame(TFrame *frame) = delete;

                // Perhaps use TObjectStreamer or TKafka.
                // TFrameStreamer should have a buffer of N frames, constantly replaced as the buffer fills up.

                ClassDef(TFrameStreamer,1);
        };
}
