/**
 **********************************************
 *
 * \file TFrameAbstract.cc
 * \brief Source code of the TFrameAbstract class
 * \author Marco Meyer \<marco.meyer@cern.ch\>
 *
 *********************************************
 */

#include "FrameFormat/Abstract/TFrameAbstract.h"
ClassImp(FrameFormat::TFrameAbstract)

#include "FrameFormat/Impl/TFrameHeader.h"

namespace FrameFormat {

    FILE *TFrameAbstract::logFile = NULL;
    TString TFrameAbstract::logFileName = "";
    
    Verbosity TFrameAbstract::verbosity = Verbosity::kNormal;

    void TFrameAbstract::SetVerbosity(Verbosity verbosity)
    {
        if( verbosity < 0) return;
        TFrameAbstract::verbosity = verbosity;
    }

    Verbosity TFrameAbstract::GetVerbosity()
    {
        return TFrameAbstract::verbosity;
    }

    bool TFrameAbstract::Verbose(Verbosity verbosity)
    {
        return TFrameAbstract::verbosity >= verbosity;
    }

    void TFrameAbstract::SetDebug(int debugLvl)
    {
        if( debugLvl < 0) return;        
        FrLibSetLvlT(::ROOT::IsImplicitMTEnabled() ? 0 : debugLvl);
    }

    char *TFrameAbstract::Version()
    {
        return FrLibVersionF();
    }

    FILE *TFrameAbstract::Logging(const char *name)
    {
        if(logFile == NULL) {

            TFrameAbstract::logFileName = name;
            TFrameAbstract::logFile = FrLibIni((char*) name, NULL, ::FrDebugLvl);
        }

        return TFrameAbstract::logFile;
    }
};